using System;
using Gluon;
using Gluon.Data;

namespace ExampleCode
{
    class MainClass
    {
        public static void Main (string[] args)
        {
            Npgsql.NpgsqlConnection connection =
                new Npgsql.NpgsqlConnection("server=localhost;user id=fog;database=FOSDEM2012");
            connection.Open();

            PersistenceContext pc = new PersistenceContext(
                connection, new Gluon.Data.Npgsql.NpgsqlPersistenceProvider());

            pc.ExecuteNonQuery("DELETE FROM fosdem_talks");
            pc.ExecuteNonQuery("DELETE FROM fosdem_people");
            pc.ExecuteNonQuery("DELETE FROM fosdem_rooms");

            Room room = new Room { Name = "K.3.601", Description = "Mono Devroom"};

            Person miguel = new Person { Fullname = "Miguel De Icaza" };
            Person jo = new Person { Fullname = "Jo Shields" };
            Person me = new Person { Fullname = "Federico Di Gregorio" };

            pc.Insert(room);
            pc.Insert(miguel);
            pc.Insert(me);
            pc.Insert(jo);

            Console.WriteLine("Federico's ID is " + me.Id);

            pc.Insert(new Talk { RoomName = room.Name, PersonId = me.Id, Title = "Gluon"});
            pc.Insert(new Talk { RoomName = room.Name, PersonId = jo.Id,
                Title = "Enough Debian packaging knowledge to hurt yourselves slightly less than you do already"});
            pc.Insert(new Talk { RoomName = room.Name, PersonId = miguel.Id, Title = "Mono — State of the Union"});

            var talks = pc.ExecuteQuery<Talk>(@"
                SELECT A.*, B.fullname
                  FROM fosdem_talks A, fosdem_people B
                 WHERE A.person_id = B.id");

            foreach (var talk in talks)
                Console.WriteLine("TALK: {0}\nROOM: {1}\nby {2}", talk.Abstract, talk.RoomName, talk.FullName);
        }
    }

    public partial class Talk
    {
        [Column("fullname", IsBackendGeneratedOnly=true)] public string FullName { get; set; }
    }
}
