using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using Gluon;
using Gluon.Data;

namespace ExampleCode
{
    
    
    [TableAttribute("fosdem_people")]
    public partial class Person : System.ComponentModel.INotifyPropertyChanged
    {
        
        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;
        
        protected virtual void OnPropertyChanged(string propertyName)
        {
            System.ComponentModel.PropertyChangedEventHandler handler = this.PropertyChanged;
            if ((handler != null))
            {
                handler(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
            }
        }
        
        public class PKey : Gluon.IPKey<Person>
        {
            
            public PKey(Person obj)
            {
                this._Id = obj.Id;
            }
            
            public PKey(int Id)
            {
                this._Id = Id;
            }
            
            private int _Id;
            
            public object GetValue(string propertyName)
            {
                if ((propertyName == "Id"))
                {
                    return this._Id;
                }
                throw new NotSupportedException();
            }
            
            public override bool Equals(object obj)
            {
                if ((obj == null))
                {
                    return false;
                }
                if ((obj.GetType() != typeof(PKey)))
                {
                    return false;
                }
                PKey other = ((PKey)(obj));
                return (this._Id == other._Id);
            }
            
            public bool Equals(Gluon.IPKey obj)
            {
                if ((obj == null))
                {
                    return false;
                }
                if ((obj.GetType() != typeof(PKey)))
                {
                    return false;
                }
                PKey other = ((PKey)(obj));
                return (this._Id == other._Id);
            }
            
            public bool Equals(Gluon.IPKey<Person> obj)
            {
                if ((obj == null))
                {
                    return false;
                }
                if ((obj.GetType() != typeof(PKey)))
                {
                    return false;
                }
                PKey other = ((PKey)(obj));
                return (this._Id == other._Id);
            }
            
            public override int GetHashCode()
            {
                return this._Id.GetHashCode();
            }
        }
        
        private int _Id;
        
        [ColumnAttribute("id", Storage="_Id", IsPrimaryKey=true, IsBackendGenerated=true)]
        public virtual int Id
        {
            get
            {
                return this._Id;
            }
            set
            {
                if ((this._Id != value))
                {
                    this._Id = value;
                    this.OnPropertyChanged("Id");
                }
            }
        }
        
        private string _Fullname;
        
        [ColumnAttribute("fullname", Storage="_Fullname", IsNullable=true)]
        public virtual string Fullname
        {
            get
            {
                return this._Fullname;
            }
            set
            {
                if ((this._Fullname != value))
                {
                    this._Fullname = value;
                    this.OnPropertyChanged("Fullname");
                }
            }
        }
        
        private string _Biography;
        
        [ColumnAttribute("biography", Storage="_Biography", IsNullable=true)]
        public virtual string Biography
        {
            get
            {
                return this._Biography;
            }
            set
            {
                if ((this._Biography != value))
                {
                    this._Biography = value;
                    this.OnPropertyChanged("Biography");
                }
            }
        }
    }
}
