using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using Gluon;
using Gluon.Data;

namespace ExampleCode
{
    
    
    [TableAttribute("fosdem_rooms")]
    public partial class Room : System.ComponentModel.INotifyPropertyChanged
    {
        
        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;
        
        protected virtual void OnPropertyChanged(string propertyName)
        {
            System.ComponentModel.PropertyChangedEventHandler handler = this.PropertyChanged;
            if ((handler != null))
            {
                handler(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
            }
        }
        
        public class PKey : Gluon.IPKey<Room>
        {
            
            public PKey(Room obj)
            {
                this._Name = obj.Name;
            }
            
            public PKey(string Name)
            {
                this._Name = Name;
            }
            
            private string _Name;
            
            public object GetValue(string propertyName)
            {
                if ((propertyName == "Name"))
                {
                    return this._Name;
                }
                throw new NotSupportedException();
            }
            
            public override bool Equals(object obj)
            {
                if ((obj == null))
                {
                    return false;
                }
                if ((obj.GetType() != typeof(PKey)))
                {
                    return false;
                }
                PKey other = ((PKey)(obj));
                return (this._Name == other._Name);
            }
            
            public bool Equals(Gluon.IPKey obj)
            {
                if ((obj == null))
                {
                    return false;
                }
                if ((obj.GetType() != typeof(PKey)))
                {
                    return false;
                }
                PKey other = ((PKey)(obj));
                return (this._Name == other._Name);
            }
            
            public bool Equals(Gluon.IPKey<Room> obj)
            {
                if ((obj == null))
                {
                    return false;
                }
                if ((obj.GetType() != typeof(PKey)))
                {
                    return false;
                }
                PKey other = ((PKey)(obj));
                return (this._Name == other._Name);
            }
            
            public override int GetHashCode()
            {
                return this._Name.GetHashCode();
            }
        }
        
        private string _Name;
        
        [ColumnAttribute("room_name", Storage="_Name", IsPrimaryKey=true)]
        public virtual string Name
        {
            get
            {
                return this._Name;
            }
            set
            {
                if ((this._Name != value))
                {
                    this._Name = value;
                    this.OnPropertyChanged("Name");
                }
            }
        }
        
        private string _Description;
        
        [ColumnAttribute("room_description", Storage="_Description", IsNullable=true)]
        public virtual string Description
        {
            get
            {
                return this._Description;
            }
            set
            {
                if ((this._Description != value))
                {
                    this._Description = value;
                    this.OnPropertyChanged("Description");
                }
            }
        }
    }
}
