using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using Gluon;
using Gluon.Data;

namespace ExampleCode
{
    
    
    [TableAttribute("fosdem_talks")]
    public partial class Talk : System.ComponentModel.INotifyPropertyChanged
    {
        
        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;
        
        protected virtual void OnPropertyChanged(string propertyName)
        {
            System.ComponentModel.PropertyChangedEventHandler handler = this.PropertyChanged;
            if ((handler != null))
            {
                handler(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
            }
        }
        
        public class PKey : Gluon.IPKey<Talk>
        {
            
            public PKey(Talk obj)
            {
                this._PersonId = obj.PersonId;
                this._RoomName = obj.RoomName;
            }
            
            public PKey(int PersonId, string RoomName)
            {
                this._PersonId = PersonId;
                this._RoomName = RoomName;
            }
            
            private int _PersonId;
            
            private string _RoomName;
            
            public object GetValue(string propertyName)
            {
                if ((propertyName == "PersonId"))
                {
                    return this._PersonId;
                }
                if ((propertyName == "RoomName"))
                {
                    return this._RoomName;
                }
                throw new NotSupportedException();
            }
            
            public override bool Equals(object obj)
            {
                if ((obj == null))
                {
                    return false;
                }
                if ((obj.GetType() != typeof(PKey)))
                {
                    return false;
                }
                PKey other = ((PKey)(obj));
                return ((this._PersonId == other._PersonId) && (this._RoomName == other._RoomName));
            }
            
            public bool Equals(Gluon.IPKey obj)
            {
                if ((obj == null))
                {
                    return false;
                }
                if ((obj.GetType() != typeof(PKey)))
                {
                    return false;
                }
                PKey other = ((PKey)(obj));
                return ((this._PersonId == other._PersonId) && (this._RoomName == other._RoomName));
            }
            
            public bool Equals(Gluon.IPKey<Talk> obj)
            {
                if ((obj == null))
                {
                    return false;
                }
                if ((obj.GetType() != typeof(PKey)))
                {
                    return false;
                }
                PKey other = ((PKey)(obj));
                return ((this._PersonId == other._PersonId) && (this._RoomName == other._RoomName));
            }
            
            public override int GetHashCode()
            {
                return (this._PersonId.GetHashCode() | this._RoomName.GetHashCode());
            }
        }
        
        private int _PersonId;
        
        [ColumnAttribute("person_id", Storage="_PersonId", IsPrimaryKey=true)]
        public virtual int PersonId
        {
            get
            {
                return this._PersonId;
            }
            set
            {
                if ((this._PersonId != value))
                {
                    this._PersonId = value;
                    this.OnPropertyChanged("PersonId");
                }
            }
        }
        
        private string _RoomName;
        
        [ColumnAttribute("room_name", Storage="_RoomName", IsPrimaryKey=true)]
        public virtual string RoomName
        {
            get
            {
                return this._RoomName;
            }
            set
            {
                if ((this._RoomName != value))
                {
                    this._RoomName = value;
                    this.OnPropertyChanged("RoomName");
                }
            }
        }
        
        private string _Title;
        
        [ColumnAttribute("title", Storage="_Title", IsNullable=true)]
        public virtual string Title
        {
            get
            {
                return this._Title;
            }
            set
            {
                if ((this._Title != value))
                {
                    this._Title = value;
                    this.OnPropertyChanged("Title");
                }
            }
        }
        
        private string _Abstract;
        
        [ColumnAttribute("abstract", Storage="_Abstract", IsNullable=true)]
        public virtual string Abstract
        {
            get
            {
                return this._Abstract;
            }
            set
            {
                if ((this._Abstract != value))
                {
                    this._Abstract = value;
                    this.OnPropertyChanged("Abstract");
                }
            }
        }
        
        private System.Nullable<System.DateTime> _Starts;
        
        [ColumnAttribute("starts", Storage="_Starts", IsNullable=true)]
        public virtual System.Nullable<System.DateTime> Starts
        {
            get
            {
                return this._Starts;
            }
            set
            {
                if ((this._Starts != value))
                {
                    this._Starts = value;
                    this.OnPropertyChanged("Starts");
                }
            }
        }
        
        private System.Nullable<System.DateTime> _Ends;
        
        [ColumnAttribute("ends", Storage="_Ends", IsNullable=true)]
        public virtual System.Nullable<System.DateTime> Ends
        {
            get
            {
                return this._Ends;
            }
            set
            {
                if ((this._Ends != value))
                {
                    this._Ends = value;
                    this.OnPropertyChanged("Ends");
                }
            }
        }
    }
}
